#!/usr/bin/perl -w
use strict;

use DBI;
my $dbh = DBI->connect("DBI:SQLite:base.sqlite","","",
	{ RaiseError => 1, AutoCommit => 1 });

# Creation de la table
$dbh->do("CREATE TABLE passwd ( login, x, uid, gid, description, home, shell )");

# Remplissage
my $insert = $dbh->prepare("INSERT INTO passwd VALUES (?,?,?,?,?,?,?)");
open PASSWD, "<", "/etc/passwd"
	or die "Erreur : $!";
while (my $ligne=<PASSWD>) {
	chomp $ligne;
	$insert->execute(split /:/,$ligne);
}

# Interrogation
my $getbylogin = $dbh->prepare("SELECT * FROM passwd WHERE login=?");
print "Login (empty to quit): ";
while (my $login = <STDIN>) {
	last if ($login eq "\n");
	chomp $login;
	$getbylogin->execute($login);
	my $rdata = $getbylogin->fetchrow_hashref();
	foreach my $clef (sort keys %$rdata) {
		printf "%13s => %s\n", $clef, $rdata->{$clef};
	}
	print "Login : ";
}
